/*
 *  Copyright (C) International Business Machines  Corp., 2005
 *  Author: 	Michael Running Wolf <marunnin@us.ibm.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 2 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *			
 *  XML-RPC xenstat standlone server 
 *
 */

    
#include <stdlib.h>
#include <stdio.h>

/*
#include <xmlrpc.h>
#include <xmlrpc_server.h>
#include <xmlrpc_server_abyss.h>
#include <xenstat.h>
#define STR_SIZE 32 
*/
#include "xenstatd.h"
#include <xmlrpc_server_abyss.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <time.h>

    /*******************  main  ***************/

int main(int const argc, 
     char ** argv) {

    xmlrpc_server_abyss_parms serverparm;
    xmlrpc_registry * registryP;
    xmlrpc_env env;

    struct rlimit mlocklimit = {RLIM_INFINITY,RLIM_INFINITY};

    if (argc != 2) {
        fprintf(stderr, "You must specify 1 argument:  port number, "
                "number on which the server will accept connections "
                "for RPCs.  You specified %d arguments.\n",  argc-1);
        exit(1);
    }
    
    printf("hello, User: %d\n", getuid());
    /* removes mlock limit prior to abyss start*/
    if( setrlimit(RLIMIT_MEMLOCK, &mlocklimit) < 0){
 	perror("failed to remove mlock limit, You Need to Be Root");
	exit(1);
    }
    /* initializes handle, need to be root to do this */
    handle = xenstat_init();
    
     

    /*
    if (handle == NULL) {
        fprintf(stderr, "Libxenstat failed initialization\n");
      //return xmlrpc error package here 
	exit(1); 
    }
    */
    xmlrpc_env_init(&env);
    registryP = xmlrpc_registry_new(&env);
    xmlrpc_registry_add_method(&env, registryP, NULL, "xenstat_gather", &xenstat_gather, NULL);


    serverparm.config_file_name = NULL;
    serverparm.registryP = registryP;
    serverparm.port_number = atoi(argv[1]);
    serverparm.log_file_name = "/tmp/xmlrpc_log";

    printf("Running XML-RPC server...\n");
    /*
    setuid(1003);
    setuid(65534);

 */
    int pid;
    printf("hello, User: %d\n", getuid());

  /* pid = fork();
   if(pid == 0)
   */
    xmlrpc_server_abyss(&env, &serverparm, XMLRPC_APSIZE(log_file_name));
    /*
   else
    printf("stopping parent\n");
    */

    return 0;
}

static xmlrpc_value * xenstat_gather(xmlrpc_env *   const env,
                                     xmlrpc_value * const param_array,
	                             void *         const user_data __attribute__((__unused__)))
{
/*
        int error = 0;
        char version[21]="";
*/
	xenstat_node * node;
	node = xenstat_get_node(handle, XENSTAT_ALL);
	
/*
	error = xenstat_get_version(handle, version); 
        printf("version= %s\n",version);
*/


    return xmlrpc_build_value(env, "i", 2);
}

void test()
{
        printf("xenstat_gather: hi\n");
}
